import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;

public class TranslucentBarMeter extends Component {

    // Double Buffering pC[W
    transient protected BufferedImage image = null;
    transient protected Graphics2D graphics = null;

    // x
    protected int alpha = 128;

    // wi/Oi̐Fɓx{
    protected Color backColor;
    protected Color foreColor;

    // ʂ̑傫Ɋ֘AvpeB
    protected int width = 0;
    protected int height = 0;

    // TCỸ`FbNptO
    protected boolean resizeFlag = false;

    // [^̍ŏ/ől
    protected double minimum = 0;
    protected double maximum = 100;

    // [^wl
    protected double value = 0;

    public TranslucentBarMeter(){
        super();
        enableEvents(AWTEvent.COMPONENT_EVENT_MASK);
    }

    public void processComponentEvent(ComponentEvent e){
        if(e.getID() == ComponentEvent.COMPONENT_RESIZED){
            resizeFlag = true;
            repaint();
        }

        super.processComponentEvent(e);
    }

    public Dimension getPreferredSize(){
        return getMinimumSize();
    }

    public Dimension getMinimumSize(){
        return new Dimension(50, 100);
    }

    public void setMinimum(double minimum){
        this.minimum = minimum;
    }

    public double getMinimum(){
        return this.minimum;
    }

    public void setMaximum(double maximum){
        this.maximum = maximum;
    }

    public double getMaximum(){
        return this.maximum;
    }

    public void setValue(double value){
        this.value = value;
        repaint();
    }

    public void setAlpha(int alpha){
        this.alpha = alpha;
    }

    public void setBackground(Color color){
        // x
        this.backColor
            = new Color(color.getRed(), color.getGreen(), color.getBlue(), alpha);
    }

    public void setForeground(Color color){
        // x
        this.foreColor
            = new Color(color.getRed(), color.getGreen(), color.getBlue(), alpha);
    }

    // o[̕`
    protected void drawBar(Graphics2D g, double value){

        // wl̑ΒlZo
        double val = (value - minimum)/ (maximum - minimum);

        // Ot̍ɕϊ
        val *= height;

        int y = height - (int)val;
        int h = (int)val;
        
        // FœhԂ
        g.setBackground(new Color(255, 255, 255, 0));
        g.clearRect(0, 0, width, height);

        // o[`
        g.setPaint(backColor);
        g.fillRect(0, 0, width, y);
        g.setPaint(foreColor);
        g.fillRect(0, y, width, h);
    }

    public void update(Graphics g){
        paint(g);
    }

    public void createBufferImage(){
        // Avbg̃TCY
        Dimension size = this.getSize();
        width = size.width;
        height = size.height;

        if(width != 0 && height != 0){
            // At@t̃C[W𐶐
            image = new BufferedImage(width, height, BufferedImage.TYPE_4BYTE_ABGR);
            graphics = (Graphics2D)image.getGraphics();
        }
    }

    public void paint(Graphics g){

        // _uobt@Op̃C[WȂ΁A
        // AOtBbNReLXgB
        // ܂ATCYꂽƂobt@C[W𐶐
        if(image == null || resizeFlag){
            createBufferImage();
            resizeFlag = false;
        }

        // o[̕`
        drawBar(graphics, value);

        // C[Wobt@̕`
        g.drawImage(image, 0, 0, width, height, this);
    }
}
